<template src="./editInfoComponent.htm"></template>

<script>

    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseWarehouseStoreObject());
        },

        data() {

            return {

                baseInfo: {

                    name: '',

                    description: '',

                    address: '',

                    public: null
                }
            }
        },

        mixins: [
            ValidationErrorsMixin
        ],

        methods: {

            parseWarehouseStoreObject() {

                let warehouse = this.$store.state.warehouse;

                this.baseInfo.name          = warehouse.name;
                this.baseInfo.description   = warehouse.description;
                this.baseInfo.address       = warehouse.address;
                this.baseInfo.public        = warehouse.public == true ? 1 : 0;
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setWarehouse', newBaseInfo);
                },

                deep: true
            }
        }
    }

</script>